package ru.dbotthepony.kommons.util

fun interface DelegateSetter<V> {
	operator fun invoke(field: Delegate<V>, value: V)

	private object PASSTHROUGH : DelegateSetter<Any?> {
		override fun invoke(field: Delegate<Any?>, value: Any?) {
			field.accept(value)
		}
	}

	companion object {
		fun <V> passthrough(): DelegateSetter<V> {
			return PASSTHROUGH as DelegateSetter<V>
		}
	}
}
